#ifndef THREAD_H_
#define THREAD_H_

#include <pthread.h>

class Thread;

void * threadMain(void * _params);

/*!
 * Signals for thread
 */
 enum THREAD_SIGNALS {
 
	THREADSIG_STOP = 0,
	THREADSIG_RUN
 };

/*!
 * Structure for passing parameters to thread
 */
struct ThreadParams {

    Thread *	thread;				//!< pointer to Thread object
};

/*!
 * Thread management class
 * Creates, starts and stops thread
 */
class Thread {

private:
	pthread_attr_t attr;			//!< thread attributes
	pthread_t	   thread;			//!< thread descriptor
	
protected:
	int			 id;				//!< thread id	
	static int   lastid;			//!< id of the last thread
	ThreadParams params;			//!< thread parameters
	int			 signal;			//!< signal for thread
	int			 status;			//!< status of thread join

public:
	Thread();
	virtual ~Thread();
	
	int start();
	int stop(); 

	virtual int run() = 0;
};

#endif /*THREAD_H_*/